Bug 471054 - focus linking of gsoap, X11 and pq into daemons and tools
focus linking of gsoap, X11 and pq into daemons and tools
Status: CLOSED ERRATA
Product: Red Hat Enterprise MRG
Classification: Red Hat
Component: condor (Show other bugs)
1.0
All Linux
medium Severity medium
: 1.3
: ---
Assigned To: Matthew Farrellee
Luigi Toscano
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-11-11 10:53 EST by Matthew Farrellee
Modified: 2012-02-09 13:11 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Previously, all daemons and command line tools were linked against the same set of libraries, which left dependencies on pcre and gsoap. This update removes these redundant dependencies. These, and other, dependencies are not necessary.
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-10-14 12:12:35 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Matthew Farrellee 2008-11-11 10:53:08 EST
Currently (7.2 and earlier), all daemons and command line tools are linked against the same set of libraries. This leaves dependencies on pcre and gsoap for command line tools and X11 for daemons and tools (only kbdd requires). These, and other, dependencies are not necessary. They are an artifact of the build system, which needs to be fixed.
Comment 1 Matthew Farrellee 2010-01-04 10:39:59 EST
Bad:

$ condor_version
$CondorVersion: 7.4.1 Dec 11 2009 BuildID: RH-7.4.1-0.7.1.el5 PRE-RELEASE $
$CondorPlatform: X86_64-LINUX_RHEL5 $
$ ldd $(which condor_shadow) | grep -e soap -e pcre -e classad
	libpcre.so.0 => /lib64/libpcre.so.0 (0x0000003210400000)
	libgsoapssl++.so.0 => /usr/lib64/libgsoapssl++.so.0 (0x0000003211400000)
	libclassad.so.0 => /usr/lib64/libclassad.so.0 (0x0000003210c00000)

Good:

$ ./release_dir/bin/condor_version 
$CondorVersion: 7.5.0 Jan  4 2010 PRE-RELEASE $
$CondorPlatform: I386-LINUX_F12 $

$ ldd release_dir/sbin/condor_shadow | grep -e soap -e pcre -e classad
	libpcre.so.0 => /lib/libpcre.so.0 (0x07c52000)
	libclassad.so.0 => /usr/lib/libclassad.so.0 (0x003e5000)
Comment 2 Matthew Farrellee 2010-01-04 11:48:17 EST
Better:

$ ./release_dir/bin/condor_version
$CondorVersion: 7.5.0 Jan  4 2010 PRE-RELEASE $
$CondorPlatform: I386-LINUX_F12 $

$ ldd release_dir/sbin/condor_shadow | grep -e soap -e pcre -e classad
	libpcre.so.0 => /lib/libpcre.so.0 (0x07c52000)
Comment 3 Matthew Farrellee 2010-01-04 12:02:15 EST
Acceptable:

$ grep libgsoap release_dir/bin/condor_* release_dir/sbin/condor_*             
Binary file release_dir/sbin/condor_collector matches
Binary file release_dir/sbin/condor_schedd matches

$ grep libclassad release_dir/bin/condor_* release_dir/sbin/condor_*
Binary file release_dir/bin/condor_check_userlogs matches
Binary file release_dir/bin/condor_dagman matches
Binary file release_dir/bin/condor_q matches
Binary file release_dir/bin/condor_submit_dag matches
Binary file release_dir/bin/condor_userlog matches
Binary file release_dir/bin/condor_userlog_job_counter matches
Comment 4 Matthew Farrellee 2010-01-04 12:54:10 EST
pcre gets pulled in for classad's regex() function and for user mapping via the MapFile - regex are not used for ALLOW/DENY security configuration
Comment 5 Matthew Farrellee 2010-01-04 12:56:34 EST
commit cfe7e27765d818a6b8d8c695d7ad2984e45dedab
Author: Matthew Farrellee <matt@>
Date:   Mon Jan 4 12:04:32 2010 -0500

    Pulled -lclassad from general LIBS, all makefiles that needed -lclassad had it explicitly
Comment 6 Matthew Farrellee 2010-01-04 13:00:44 EST
Acceptable:

$ grep libpq /usr/sbin/condor_*
Binary file /usr/sbin/condor_advertise matches
Binary file /usr/sbin/condor_dbmsd matches
Binary file /usr/sbin/condor_fetchlog matches
Binary file /usr/sbin/condor_off matches
Binary file /usr/sbin/condor_on matches
Binary file /usr/sbin/condor_preen matches
Binary file /usr/sbin/condor_quill matches
Binary file /usr/sbin/condor_reconfig matches
Binary file /usr/sbin/condor_restart matches
Binary file /usr/sbin/condor_store_cred matches
$ grep libpq /usr/bin/condor_*
Binary file /usr/bin/condor_cod matches
Binary file /usr/bin/condor_config_val matches
Binary file /usr/bin/condor_dump_history matches
Binary file /usr/bin/condor_findhost matches
Binary file /usr/bin/condor_history matches
Binary file /usr/bin/condor_load_history matches
Binary file /usr/bin/condor_q matches
Binary file /usr/bin/condor_qedit matches
Binary file /usr/bin/condor_reschedule matches
Binary file /usr/bin/condor_ssh_to_job matches
Binary file /usr/bin/condor_stats matches
Binary file /usr/bin/condor_transfer_data matches
Binary file /usr/bin/condor_userprio matches
Binary file /usr/bin/condor_vacate matches
Binary file /usr/bin/condor_version matches
Binary file /usr/bin/condor_wait matches
Comment 7 Matthew Farrellee 2010-01-04 13:13:22 EST
Fixed in 7.4.2-0.1
Comment 8 Matthew Farrellee 2010-04-21 10:10:04 EDT
As of 7.4.3-0.11, libpq should be removed entirely
Comment 9 Matthew Farrellee 2010-04-21 10:17:27 EDT
Verify with the "Better" and "Acceptable" comments
Comment 10 Luigi Toscano 2010-06-01 11:57:19 EDT
libpq is not linked anymore.
libX11 is linked by condor_kbdd only.
The usage of libgsoap and libclassad has been restricted according to Comment #3 .
(The usage of pcre has been moved to bz584825).

Verified on condor 7.4.3-0.16 on RHEL 4.8/5.5, i386/x86_64.
Comment 11 Florian Nadge 2010-10-07 13:25:02 EDT
    Technical note added. If any revisions are required, please edit the "Technical Notes" field
    accordingly. All revisions will be proofread by the Engineering Content Services team.
    
    New Contents:
Previously, all daemons and command line tools were linked against the same set of libraries, which left dependencies on pcre and gsoap. This update removes these redundant dependencies. These, and other, dependencies are not necessary.
Comment 13 errata-xmlrpc 2010-10-14 12:12:35 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2010-0773.html

Note You need to log in before you can comment on or make changes to this bug.